package com.ibm.etools.iseries.ae.customtags.gen;

/*  (C) Copyright IBM Corporation, 2003                        
 * All rights reserved. Licensed Materials Property of IBM     
 * US Government Users Restricted Rights -                     
 * Use, duplication or disclosure restricted by                
 * GSA ADP Schedule Contract with IBM Corp.                    
 */

import com.ibm.as400ad.code400.dom.constants.IRecordType;
import com.ibm.etools.iseries.webfacing.convert.external.IFieldTagGenerator;
import com.ibm.etools.iseries.webfacing.convert.external.IFieldTagInput;
import com.ibm.etools.iseries.webfacing.convert.external.IRawWebSetting;
import com.ibm.etools.iseries.webfacing.convert.external.ITagOutput;
/**
 * @author hockings
 *
 * This is a simple class that will simply wrapper the default html generated for a field with a tag
 */
public class MTFldTagGen implements IFieldTagGenerator
{
    public boolean generate(IFieldTagInput input, ITagOutput output)
    {
        boolean rv = false;
        try
        {
            String prefix = "wf";
            String library = "/webface";
            String tagstring = "";
            // Tell the record that another taglib directive needs to be added
            output.addHtmlHeader(prefix, library);

            // Get the type of the record
            IRecordType rt = input.getRecordType();

            // now start generating the tag
            tagstring += "<wf:mtfld field=\"" + input.getFieldName() + "\" record=\"" + input.getRecordName() + "\"";
            if (true == rt.isSubFile())
            {
                tagstring += " sflrow=\"<%=rrn%>\"";
            }
            tagstring += ">";

            // Now we are in the body of the tag
            // Just obtain the default (non-tag) html generated for this field
            tagstring += input.getFieldHTML();

            // This tag is done so close it off
            tagstring += "</wf:mtfld>";

            // WAS 4.0 won't allow the inclusion of JSP:include inside a tag
            // or rather it won't allow the flush="true" option which is the only
            // valid option.  So if that exists in the string simply don't write out
            // the tag and return false so that the normal generation takes
            // place.  If you will only be generating for WAS 5+ or won't be
            // using imbedded JSP's in the fields (buttons in place) then this
            // check could be removed.
            if (tagstring.indexOf("flush=\"true\"") > 0)
            {
                tagstring = null;
                rv = false;
                output.logMessage("DBG", 5, "MTFldTagGen: Skipping field " + input.getRecordName() +"."+input.getFieldName() + ", generated contents look like an included JSP");
            }
            else
            {
                // Then send the output to be included in the JSP           
                output.setTag(tagstring);

                // return true to indicate that the field jsp code was emitted OK
                rv = true;
            }
        }
        catch (Throwable t)
        {
            // getting an exception can't be a good thing
            // so log it and return false and the result will be thrown away
            output.logMessage("ERR", 1, "Exception in MTFldTagGen =" + t);
            rv = false;
        }

        return rv;
    }
}