package com.ibm.etools.iseries.ae.customtags.gen;

/*  (C) Copyright IBM Corporation, 2003                        
 * All rights reserved. Licensed Materials Property of IBM     
 * US Government Users Restricted Rights -                     
 * Use, duplication or disclosure restricted by                
 * GSA ADP Schedule Contract with IBM Corp.                    
 */

import com.ibm.as400ad.code400.dom.constants.IRecordType;
import com.ibm.etools.iseries.webfacing.convert.external.IWSTagGenerator;
import com.ibm.etools.iseries.webfacing.convert.external.IWSTagInput;
import com.ibm.etools.iseries.webfacing.convert.external.IRawWebSetting;
import com.ibm.etools.iseries.webfacing.convert.external.ITagOutput;
/**
 * @author hockings
 *
 * This is a simple class that will emit a WebFacing Program Defined HTML tag for the called field
 */
public class PgmDefTagGen implements IWSTagGenerator
{
    public boolean generate(IWSTagInput input, ITagOutput output)
    {
        boolean rv = false;
        try
        {
            String prefix = "wf";
            String library = "/webface";
            // Tell the record that another taglib directive needs to be added
            output.addHtmlHeader(prefix, library);

            // Get the type of the record
            IRecordType rt = input.getRecordType();

            // Start generating the tag
            String tagstring = "<wf:pgmdef field=\"" + input.getFieldName() + "\" record=\"" + input.getRecordName() + "\"";
            if (true == rt.isSubFile())
            {
                tagstring += " sflrow=\"<%=rrn%>\"";
            }
            tagstring += "> </wf:pgmdef>";

            // Note that there is no real body content for this tag as it
            // will obtain it's content at run time.

            // This tag is done so output the result
            output.setTag(tagstring);

            // Return true to indicate that the field jsp code was emitted OK
            rv = true;
        }
        catch (Throwable t)
        {
            // getting an exception can't be a good thing
            // so log it and return false and the result will be thrown away
            output.logMessage("ERR", 1, "Exception in PgmDefTagGen =" + t);
            rv = false;
        }
        return rv;
    }
}