package com.ibm.etools.iseries.webfacing.tags.impl;

/*  (C) Copyright IBM Corporation, 2003                        
 * All rights reserved. Licensed Materials Property of IBM     
 * US Government Users Restricted Rights -                     
 * Use, duplication or disclosure restricted by                
 * GSA ADP Schedule Contract with IBM Corp.                    
 */

import java.io.IOException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyContent;

/** 
 * @author hockings
 *
 * Simple enclosing tag to contain the default WebFacing field HTML
 */
public class WFMTFld extends WFFieldTagSupport
{
    public static final String Copyright = "(c) Copyright IBM Corporation 2002-2003. All Rights Reserved.";
    /*
     * For default field html content simply have the JSP processor process the body content of this tag
     **/
    public int doStartTag()
    {
        return EVAL_BODY_TAG;
    }

    /*
     * Get the processed body content and include it inline
     */
    public int doAfterBody()
    {
        try
        {
            BodyContent body = getBodyContent();
            String bodyString = body.getString();
            JspWriter writer = body.getEnclosingWriter();
            writer.write(bodyString);
        }
        catch (Exception e)
        {
        	//
        }
        return SKIP_BODY;
    }
    
    /*
     * Simply carry on with the rest of the page
     */
    public int doEndTag()
    {
        return EVAL_PAGE;
    }
}
