package com.ibm.etools.iseries.webfacing.tags.impl;

/*  (C) Copyright IBM Corporation, 2003                        
 * All rights reserved. Licensed Materials Property of IBM     
 * US Government Users Restricted Rights -                     
 * Use, duplication or disclosure restricted by                
 * GSA ADP Schedule Contract with IBM Corp.                    
 */

import java.io.IOException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyContent;
/**
 * @author hockings
 *
 * Simple enclosing tag to contain user defined HTML
 */
public class WFProgDef extends WFFieldTagSupport
{
    public static final String Copyright = "(c) Copyright IBM Corporation 2002-2003. All Rights Reserved.";

    /**
     * With Program defined fields there is no content in the JSP, the content will be extracted from the
     * incoming record data buffer.  However because the base class is a BodyTag we need to
     * process the body so that the after body and end tag methods will be called.  Also
     * make sure that the body contains something (default is one space which will be thrown away).
     */
    public int doStartTag()
    {
        return EVAL_BODY_TAG;
    }

    /**
     * Only process the body once so this always returns SKIP_BODY
     */
    public int doAfterBody()
    {
        return SKIP_BODY;
    }

    /**
     * For Program Defined content simply have the JSP processor handle any included content
     **/
    public int doEndTag()
    {
        int rv = EVAL_PAGE;
        try
        {
            if (true == isVisible())
            {
                logMsg("DBG", 6, "field " + getRecord() + "." + getField() + " IS visible");
                BodyContent body = getBodyContent();
                String bodyString = getFieldValue();
                if (null != bodyString)
                {
                    JspWriter writer = body.getEnclosingWriter();
                    try
                    {
                        writer.print("<span id=\"" + getFieldId() + "\">" + bodyString + "</span>");
                    }
                    catch (IOException e)
                    {
                        logMsg("ERR", 1, "exception in WFProgDef.doEndTag for " + getField() + " in " + getRecord() + " :\n" + e);
                    }
                }
            }
            else
            {
                logMsg("DBG", 6, "field " + getField() + " is NOT visible");
            }
        }
        catch (Exception e)
        {
            logMsg("ERR", 1, "Exception in WFProgDef.doEndTag :\n" + e);
        }
        return rv;
    }

}
