package com.ibm.etools.iseries.webfacing.tags.impl;
 
/*  (C) Copyright IBM Corporation, 2003                        
 * All rights reserved. Licensed Materials Property of IBM     
 * US Government Users Restricted Rights -                     
 * Use, duplication or disclosure restricted by                
 * GSA ADP Schedule Contract with IBM Corp.                    
 */
 
import java.io.IOException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyContent;
 
/**
 * @author hockings
 *
 * Simple enclosing tag to contain user defined HTML
 */
public class WFUserDef extends WFFieldTagSupport
{
    public static final String Copyright = "(c) Copyright IBM Corporation 2002-2003. All Rights Reserved.";
    /**
     * For User Defined content simply have the JSP processor handle any included content
     **/
    public int doAfterBody()
    {
        int rv = SKIP_BODY;
        BodyContent body = getBodyContent();
        if (true == isVisible())
        {
            String bodyString = body.getString();
            if (null != bodyString)
            {
                JspWriter writer = body.getEnclosingWriter();
                try
                {
                    writer.print("<span id=\"" + getFieldId() + "\">" + bodyString + "</span>");
                }
                catch (IOException e)
                {
                    logMsg("ERR", 1, "exception in WFUserDef.doAfterBody for " + getField() + " in " + getRecord() + " :\n" + e);
                }
            }
        }
        else
        {
            logMsg("DBG", 3, "field " + getField() + " is not visible");
        }
        return rv;
    }
}
